package ecfdemo.sharedObject;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.ecf.core.identity.ID;
import org.eclipse.ecf.core.identity.StringID;
import org.eclipse.ecf.core.sharedobject.ReplicaSharedObjectDescription;
import org.eclipse.ecf.core.sharedobject.SharedObjectInitException;
import org.eclipse.ecf.core.sharedobject.events.ISharedObjectActivatedEvent;
import org.eclipse.ecf.core.util.Event;
import org.eclipse.ecf.core.util.IEventProcessor;

/**
 * 
 * @author jungeun07.park
 *
 */
public class MySharedObject extends AbstractSharedZObject {
	
	private static final String OBJECT_PROPERTY = "name";
	
	private String name;
	
	public MySharedObject() { 
		super();
	}
	
	
	public MySharedObject(String name) {
		super();
		this.name = name;
	}
	
	
	public String getSharedProperty() {
		return name;
	}
	
	protected void initialize() throws SharedObjectInitException {
		super.initialize();
		
		if (isPrimary()) {
			addEventProcessor(new IEventProcessor() {
				public boolean processEvent(Event event) {
					if (event instanceof ISharedObjectActivatedEvent) {
						ISharedObjectActivatedEvent ae = (ISharedObjectActivatedEvent) event;
						if (ae.getActivatedID().equals(getID()) && isConnected()) {
								MySharedObject.this.replicateToRemoteContainers(
										new ID[]{null});
						}
						
					} 
					return false;
				}
			});
		} else {
			Map properties = getProperties();
			this.name = (String) properties.get(OBJECT_PROPERTY);
		}		
	}
	
	protected ReplicaSharedObjectDescription getReplicaDescription(ID receiver) {
		HashMap properties = new HashMap(); 
		properties.put(OBJECT_PROPERTY, this.name);
	
		return new ReplicaSharedObjectDescription(this.getClass(), getID(),
				getConfig().getHomeContainerID(), properties);
	}

	public void replicateObjectToRemote(StringID remoteContainers) {
		super.replicateObjectToRemote(remoteContainers);
	}
	
	public void handleCallRequest(String message) {
		System.out.println("Message Recieved :"+ message);
	}
	
	
}


